---
title: WebGLVertexArrayObject
slug: Web/API/WebGLVertexArrayObject
tags:
  - API
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLVertexArrayObject</code></strong> interface is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a>, represents vertex array objects (VAOs) pointing to vertex array data, and provides names for different sets of vertex data.</p>

<p>When working with <code>WebGLVertexArrayObject</code> objects, the following methods are useful:</p>

<ul>
 <li>{{domxref("WebGL2RenderingContext.createVertexArray()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.deleteVertexArray()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.isVertexArray()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.bindVertexArray()")}}</li>
</ul>

<div class="note">
<p><strong>WebGL 1:</strong> The {{domxref("OES_vertex_array_object")}} extension allows you to use vertex array objects in a WebGL 1 context.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var vao = gl.createVertexArray();
gl.bindVertexArray(vao);

// ...
// calls to bindBuffer or vertexAttribPointer
// which will be "recorded" in the VAO
// ...</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.6", "WebGLVertexArrayObject")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLVertexArrayObject")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("OES_vertex_array_object")}}</li>
</ul>
